Index: /trunk/src/VBox/VMM/VMMAll/IEMAllInstOneByte.cpp.h
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/IEMAllInstOneByte.cpp.h	(revision 103349)
+++ /trunk/src/VBox/VMM/VMMAll/IEMAllInstOneByte.cpp.h	(revision 103350)
@@ -4681,7 +4681,7 @@
                 IEM_MC_BEGIN(3, 0, 0, 0); \
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX(); \
-                IEM_MC_ARG(uint16_t *,      pu16Dst,                    0); \
-                IEM_MC_ARG_CONST(uint16_t,  u16Src, /*=*/ (int8_t)u8Imm,1); \
-                IEM_MC_ARG(uint32_t *,      pEFlags,                    2); \
+                IEM_MC_ARG(uint16_t *,      pu16Dst,                                        0); \
+                IEM_MC_ARG_CONST(uint16_t,  u16Src, /*=*/ (uint16_t)(int16_t)(int8_t)u8Imm, 1); \
+                IEM_MC_ARG(uint32_t *,      pEFlags,                                        2); \
                 \
                 IEM_MC_REF_GREG_U16(pu16Dst, IEM_GET_MODRM_RM(pVCpu, bRm)); \
@@ -4696,7 +4696,7 @@
                 IEM_MC_BEGIN(3, 0, IEM_MC_F_MIN_386, 0); \
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX(); \
-                IEM_MC_ARG(uint32_t *,      pu32Dst,                    0); \
-                IEM_MC_ARG_CONST(uint32_t,  u32Src, /*=*/ (int8_t)u8Imm,1); \
-                IEM_MC_ARG(uint32_t *,      pEFlags,                    2); \
+                IEM_MC_ARG(uint32_t *,      pu32Dst,                                        0); \
+                IEM_MC_ARG_CONST(uint32_t,  u32Src, /*=*/ (uint32_t)(int32_t)(int8_t)u8Imm, 1); \
+                IEM_MC_ARG(uint32_t *,      pEFlags,                                        2); \
                 \
                 IEM_MC_REF_GREG_U32(pu32Dst, IEM_GET_MODRM_RM(pVCpu, bRm)); \
@@ -4712,7 +4712,7 @@
                 IEM_MC_BEGIN(3, 0, IEM_MC_F_64BIT, 0); \
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX(); \
-                IEM_MC_ARG(uint64_t *,      pu64Dst,                    0); \
-                IEM_MC_ARG_CONST(uint64_t,  u64Src, /*=*/ (int8_t)u8Imm,1); \
-                IEM_MC_ARG(uint32_t *,      pEFlags,                    2); \
+                IEM_MC_ARG(uint64_t *,      pu64Dst,                                        0); \
+                IEM_MC_ARG_CONST(uint64_t,  u64Src, /*=*/ (uint64_t)(int64_t)(int8_t)u8Imm, 1); \
+                IEM_MC_ARG(uint32_t *,      pEFlags,                                        2); \
                 \
                 IEM_MC_REF_GREG_U64(pu64Dst, IEM_GET_MODRM_RM(pVCpu, bRm)); \
@@ -4745,9 +4745,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,       bUnmapInfo); \
-                    IEM_MC_ARG(uint16_t *,      pu16Dst,                            0); \
+                    IEM_MC_ARG(uint16_t *,      pu16Dst,                                    0); \
                     IEM_MC_MEM_MAP_U16_RW(pu16Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint16_t,  u16Src,  (int16_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                    2); \
+                    IEM_MC_ARG_CONST(uint16_t,  u16Src,  (uint16_t)(int16_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                            2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnNormalU16, pu16Dst, u16Src, pEFlags); \
@@ -4768,9 +4768,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,       bUnmapInfo); \
-                    IEM_MC_ARG(uint32_t *,      pu32Dst,                            0); \
+                    IEM_MC_ARG(uint32_t *,      pu32Dst,                                    0); \
                     IEM_MC_MEM_MAP_U32_RW(pu32Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint32_t,  u32Src,  (int32_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                    2); \
+                    IEM_MC_ARG_CONST(uint32_t,  u32Src,  (uint32_t)(int32_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                            2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnNormalU32, pu32Dst, u32Src, pEFlags); \
@@ -4791,9 +4791,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,       bUnmapInfo); \
-                    IEM_MC_ARG(uint64_t *,      pu64Dst,                            0); \
+                    IEM_MC_ARG(uint64_t *,      pu64Dst,                                    0); \
                     IEM_MC_MEM_MAP_U64_RW(pu64Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint64_t,  u64Src,  (int64_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                    2); \
+                    IEM_MC_ARG_CONST(uint64_t,  u64Src,  (uint64_t)(int64_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                            2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnNormalU64, pu64Dst, u64Src, pEFlags); \
@@ -4824,9 +4824,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,       bUnmapInfo); \
-                    IEM_MC_ARG(uint16_t *,      pu16Dst,                            0); \
+                    IEM_MC_ARG(uint16_t *,      pu16Dst,                                    0); \
                     IEM_MC_MEM_MAP_U16_ATOMIC(pu16Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint16_t,  u16Src,  (int16_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                    2); \
+                    IEM_MC_ARG_CONST(uint16_t,  u16Src,  (uint16_t)(int16_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                            2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnLockedU16, pu16Dst, u16Src, pEFlags); \
@@ -4847,9 +4847,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,       bUnmapInfo); \
-                    IEM_MC_ARG(uint32_t *,      pu32Dst,                    0); \
+                    IEM_MC_ARG(uint32_t *,      pu32Dst,                                    0); \
                     IEM_MC_MEM_MAP_U32_ATOMIC(pu32Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint32_t,  u32Src,  (int32_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                    2); \
+                    IEM_MC_ARG_CONST(uint32_t,  u32Src,  (uint32_t)(int32_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                            2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnLockedU32, pu32Dst, u32Src, pEFlags); \
@@ -4870,9 +4870,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,       bUnmapInfo); \
-                    IEM_MC_ARG(uint64_t *,      pu64Dst,                            0); \
+                    IEM_MC_ARG(uint64_t *,      pu64Dst,                                    0); \
                     IEM_MC_MEM_MAP_U64_ATOMIC(pu64Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint64_t,  u64Src, (int64_t)(int8_t)u8Imm,     1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                    2); \
+                    IEM_MC_ARG_CONST(uint64_t,  u64Src, (uint64_t)(int64_t)(int8_t)u8Imm,   1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(    pEFlags, EFlags,                            2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnLockedU64, pu64Dst, u64Src, pEFlags); \
@@ -4903,7 +4903,7 @@
                 IEM_MC_BEGIN(3, 0, 0, 0); \
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX(); \
-                IEM_MC_ARG(uint16_t *,      pu16Dst,                    0); \
-                IEM_MC_ARG_CONST(uint16_t,  u16Src, /*=*/ (int8_t)u8Imm,1); \
-                IEM_MC_ARG(uint32_t *,      pEFlags,                    2); \
+                IEM_MC_ARG(uint16_t *,      pu16Dst,                                        0); \
+                IEM_MC_ARG_CONST(uint16_t,  u16Src, /*=*/ (uint16_t)(int16_t)(int8_t)u8Imm, 1); \
+                IEM_MC_ARG(uint32_t *,      pEFlags,                                        2); \
                 \
                 IEM_MC_REF_GREG_U16(pu16Dst, IEM_GET_MODRM_RM(pVCpu, bRm)); \
@@ -4918,7 +4918,7 @@
                 IEM_MC_BEGIN(3, 0, IEM_MC_F_MIN_386, 0); \
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX(); \
-                IEM_MC_ARG(uint32_t *,      pu32Dst,                    0); \
-                IEM_MC_ARG_CONST(uint32_t,  u32Src, /*=*/ (int8_t)u8Imm,1); \
-                IEM_MC_ARG(uint32_t *,      pEFlags,                    2); \
+                IEM_MC_ARG(uint32_t *,      pu32Dst,                                        0); \
+                IEM_MC_ARG_CONST(uint32_t,  u32Src, /*=*/ (uint32_t)(int32_t)(int8_t)u8Imm, 1); \
+                IEM_MC_ARG(uint32_t *,      pEFlags,                                        2); \
                 \
                 IEM_MC_REF_GREG_U32(pu32Dst, IEM_GET_MODRM_RM(pVCpu, bRm)); \
@@ -4933,7 +4933,7 @@
                 IEM_MC_BEGIN(3, 0, IEM_MC_F_64BIT, 0); \
                 IEMOP_HLP_DONE_DECODING_NO_LOCK_PREFIX(); \
-                IEM_MC_ARG(uint64_t *,      pu64Dst,                    0); \
-                IEM_MC_ARG_CONST(uint64_t,  u64Src, /*=*/ (int8_t)u8Imm,1); \
-                IEM_MC_ARG(uint32_t *,      pEFlags,                    2); \
+                IEM_MC_ARG(uint64_t *,      pu64Dst,                                        0); \
+                IEM_MC_ARG_CONST(uint64_t,  u64Src, /*=*/ (uint64_t)(int64_t)(int8_t)u8Imm, 1); \
+                IEM_MC_ARG(uint32_t *,      pEFlags,                                        2); \
                 \
                 IEM_MC_REF_GREG_U64(pu64Dst, IEM_GET_MODRM_RM(pVCpu, bRm)); \
@@ -4966,9 +4966,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,        bUnmapInfo); \
-                    IEM_MC_ARG(uint16_t const *, pu16Dst,                           0); \
+                    IEM_MC_ARG(uint16_t const *, pu16Dst,                                   0); \
                     IEM_MC_MEM_MAP_U16_RO(pu16Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint16_t,   u16Src, (int16_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(     pEFlags, EFlags,                   2); \
+                    IEM_MC_ARG_CONST(uint16_t,   u16Src, (uint16_t)(int16_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(     pEFlags, EFlags,                           2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnNormalU16, pu16Dst, u16Src, pEFlags); \
@@ -4989,9 +4989,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,        bUnmapInfo); \
-                    IEM_MC_ARG(uint32_t const *, pu32Dst,                           0); \
+                    IEM_MC_ARG(uint32_t const *, pu32Dst,                                   0); \
                     IEM_MC_MEM_MAP_U32_RO(pu32Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint32_t,   u32Src, (int32_t)(int8_t)u8Imm,    1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(     pEFlags, EFlags,                   2); \
+                    IEM_MC_ARG_CONST(uint32_t,   u32Src, (uint32_t)(int32_t)(int8_t)u8Imm,  1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(     pEFlags, EFlags,                           2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnNormalU32, pu32Dst, u32Src, pEFlags); \
@@ -5012,9 +5012,9 @@
                     \
                     IEM_MC_LOCAL(uint8_t,        bUnmapInfo); \
-                    IEM_MC_ARG(uint64_t const *, pu64Dst,                       0); \
+                    IEM_MC_ARG(uint64_t const *, pu64Dst,                                   0); \
                     IEM_MC_MEM_MAP_U64_RO(pu64Dst, bUnmapInfo, pVCpu->iem.s.iEffSeg, GCPtrEffDst); \
                     \
-                    IEM_MC_ARG_CONST(uint64_t,  u64Src, (int64_t)(int8_t)u8Imm, 1); \
-                    IEM_MC_ARG_LOCAL_EFLAGS(     pEFlags, EFlags,               2); \
+                    IEM_MC_ARG_CONST(uint64_t,  u64Src, (uint64_t)(int64_t)(int8_t)u8Imm,   1); \
+                    IEM_MC_ARG_LOCAL_EFLAGS(     pEFlags, EFlags,                           2); \
                     IEM_MC_FETCH_EFLAGS(EFlags); \
                     IEM_MC_CALL_VOID_AIMPL_3(a_fnNormalU64, pu64Dst, u64Src, pEFlags); \
Index: /trunk/src/VBox/VMM/VMMAll/IEMAllThrdPython.py
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/IEMAllThrdPython.py	(revision 103349)
+++ /trunk/src/VBox/VMM/VMMAll/IEMAllThrdPython.py	(revision 103350)
@@ -1369,4 +1369,5 @@
                                   or sRef in ( 'int8_t',    'int16_t',    'int32_t',    'int64_t',
                                                'INT8_C',    'INT16_C',    'INT32_C',    'INT64_C',
+                                               'uint8_t',   'uint16_t',   'uint32_t',   'uint64_t',
                                                'UINT8_C',   'UINT16_C',   'UINT32_C',   'UINT64_C',
                                                'UINT8_MAX', 'UINT16_MAX', 'UINT32_MAX', 'UINT64_MAX',