Index: /trunk/src/VBox/Debugger/VBoxDbg.cpp
===================================================================
--- /trunk/src/VBox/Debugger/VBoxDbg.cpp	(revision 103461)
+++ /trunk/src/VBox/Debugger/VBoxDbg.cpp	(revision 103462)
@@ -220,15 +220,13 @@
  *
  * @returns VBox status code.
- * @param   pGui            The instance returned by DBGGuiCreate().
- * @param   pszFilter       Filter pattern.
- * @param   pszExpand       Expand pattern.
- * @param   pszAdvFilter    Advanced filter configuration string (min/max/regexp
- *                          on sub-trees).
- */
-DBGDECL(int) DBGGuiShowStatistics(PDBGGUI pGui, const char *pszFilter, const char *pszExpand, const char *pszAdvFilter)
+ * @param   pGui        The instance returned by DBGGuiCreate().
+ * @param   pszFilter   Filter pattern.
+ * @param   pszExpand   Expand pattern.
+ */
+DBGDECL(int) DBGGuiShowStatistics(PDBGGUI pGui, const char *pszFilter, const char *pszExpand)
 {
     AssertReturn(pGui, VERR_INVALID_PARAMETER);
     AssertMsgReturn(pGui->u32Magic == DBGGUI_MAGIC, ("u32Magic=%#x\n", pGui->u32Magic), VERR_INVALID_PARAMETER);
-    return pGui->pVBoxDbgGui->showStatistics(pszFilter, pszExpand, pszAdvFilter);
+    return pGui->pVBoxDbgGui->showStatistics(pszFilter, pszExpand);
 }
 
Index: /trunk/src/VBox/Debugger/VBoxDbgGui.cpp
===================================================================
--- /trunk/src/VBox/Debugger/VBoxDbgGui.cpp	(revision 103461)
+++ /trunk/src/VBox/Debugger/VBoxDbgGui.cpp	(revision 103462)
@@ -182,5 +182,5 @@
 
 int
-VBoxDbgGui::showStatistics(const char *pszFilter, const char *pszExpand, const char *pszAdvFilter)
+VBoxDbgGui::showStatistics(const char *pszFilter, const char *pszExpand)
 {
     if (!m_pDbgStats)
@@ -189,5 +189,4 @@
                                        pszFilter && *pszFilter ? pszFilter :  "*",
                                        pszExpand && *pszExpand ? pszExpand : NULL,
-                                       pszAdvFilter && *pszAdvFilter ? pszAdvFilter : NULL,
                                        2, m_pParent);
         connect(m_pDbgStats, SIGNAL(destroyed(QObject *)), this, SLOT(notifyChildDestroyed(QObject *)));
Index: /trunk/src/VBox/Debugger/VBoxDbgGui.h
===================================================================
--- /trunk/src/VBox/Debugger/VBoxDbgGui.h	(revision 103461)
+++ /trunk/src/VBox/Debugger/VBoxDbgGui.h	(revision 103462)
@@ -103,10 +103,8 @@
      *
      * @returns VBox status code.
-     * @param   pszFilter       Filter pattern.
-     * @param   pszExpand       Expand pattern.
-     * @param   pszAdvFilter    Advanced filter configuration string (min/max/regexp
-     *                          on sub-trees).
-     */
-    int showStatistics(const char *pszFilter, const char *pszExpand, const char *pszAdvFilter);
+     * @param   pszFilter   Filter pattern.
+     * @param   pszExpand   Expand pattern.
+     */
+    int showStatistics(const char *pszFilter, const char *pszExpand);
 
     /**
Index: /trunk/src/VBox/Debugger/VBoxDbgStatsQt.cpp
===================================================================
--- /trunk/src/VBox/Debugger/VBoxDbgStatsQt.cpp	(revision 103461)
+++ /trunk/src/VBox/Debugger/VBoxDbgStatsQt.cpp	(revision 103462)
@@ -719,15 +719,11 @@
      * Constructor.
      *
-     * @param   a_pszAdvFilter  Configuration string from the command line or such.
      * @param   a_pParent       The parent object.
      */
-    VBoxDbgStatsSortFileProxyModel(const char *a_pszAdvFilter, QObject *a_pParent);
+    VBoxDbgStatsSortFileProxyModel(QObject *a_pParent);
 
     /** Destructor */
     virtual ~VBoxDbgStatsSortFileProxyModel()
     {}
-
-    /** Gets the unused-rows visibility status. */
-    bool isShowingUnusedRows() const { return m_fShowUnusedRows; }
 
     /** Sets whether or not to show unused rows (all zeros). */
@@ -3883,5 +3879,5 @@
     QModelIndex Idx = m_pCurMenu ? m_CurIndex : currentIndex();
     if (Idx.isValid())
-        Idx = myGetRootIndex();
+        Idx == myGetRootIndex();
     Idx = m_pProxyModel->mapToSource(Idx);
     PDBGGUISTATSNODE pNode = m_pVBoxModel->nodeFromIndex(Idx);
@@ -4091,5 +4087,5 @@
 
 VBoxDbgStats::VBoxDbgStats(VBoxDbgGui *a_pDbgGui, const char *pszFilter /*= NULL*/, const char *pszExpand /*= NULL*/,
-                           const char *pszAdvFilter /*= NULL*/, unsigned uRefreshRate/* = 0*/, QWidget *pParent/* = NULL*/)
+                           unsigned uRefreshRate/* = 0*/, QWidget *pParent/* = NULL*/)
     : VBoxDbgBaseWindow(a_pDbgGui, pParent, "Statistics")
     , m_PatStr(pszFilter), m_pPatCB(NULL), m_uRefreshRate(0), m_pTimer(NULL), m_pView(NULL)
@@ -4153,5 +4149,4 @@
     VBoxDbgStatsSortFileProxyModel *pProxyModel = new VBoxDbgStatsSortFileProxyModel(this);
     m_pView = new VBoxDbgStatsView(a_pDbgGui, pModel, pProxyModel, this);
-    pCheckBox->setCheckState(pProxyModel->isShowingUnusedRows() ? Qt::Checked : Qt::Unchecked)
 #else
     m_pView = new VBoxDbgStatsView(a_pDbgGui, pModel, NULL, this);
Index: /trunk/src/VBox/Debugger/VBoxDbgStatsQt.h
===================================================================
--- /trunk/src/VBox/Debugger/VBoxDbgStatsQt.h	(revision 103461)
+++ /trunk/src/VBox/Debugger/VBoxDbgStatsQt.h	(revision 103462)
@@ -244,11 +244,9 @@
      * @param   pszExpand       Initial expansion pattern. NULL means nothing is
      *                          expanded.
-     * @param   pszAdvFilter    Advanced filter configuration string (min/max/regexp
-     *                          on sub-trees).
      * @param   uRefreshRate    The refresh rate. 0 means not to refresh and is the default.
      * @param   pParent         Parent widget.
      */
     VBoxDbgStats(VBoxDbgGui *a_pDbgGui, const char *pszFilter = NULL, const char *pszExpand = NULL,
-                 const char *pszAdvFilter = NULL, unsigned uRefreshRate = 0, QWidget *pParent = NULL);
+                 unsigned uRefreshRate = 0, QWidget *pParent = NULL);
 
     /** Destructor. */